/****************************************************************
 Licensed Materials - Property of IBM and/or HCL 
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/

package com.hcl.test.rm.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * An instance of this class is produced by the framework from the @RMDataCollector annotation found in the Data Collector Paramaters class.<br/>
 * Hence, Data Collectors are not expected to create instances of this class.
 */
@ApiModel(description = "Provides information about a Resource Monitoring Data Collector; undocumented fields are used internally and subject to change; here is the list of public fields")
public class RMDataCollectorInfo extends RMModelBase {

	private String dataCollectorId;
	
	@ApiModelProperty(hidden = true, notes = "The base URL to be appended with specific flavours to build the specific URLs")
	private String baseUrl;

	private String title;
	@ApiModelProperty(hidden = true)
	private String titlePlural;
	@ApiModelProperty(hidden = true)
	private String addCommand;
	@ApiModelProperty(hidden = true)
	private String addAnotherCommand;
	
	@ApiModelProperty("The fixed string uniquely identifying this Data Collector")
	public String getDataCollectorId() {
		return dataCollectorId;
	}
	
	public void setDataCollectorId(String dataCollectorId) {
		this.dataCollectorId = dataCollectorId;
	}
	
	public String getBaseUrl() {
		return baseUrl;
	}

	public void setBaseUrl(String baseUrl) {
		this.baseUrl = baseUrl;
	}

	@ApiModelProperty("A user facing string depicting this Data Collector")
	public String getTitle() {
		return title;
	}
	
	public void setTitle(String title) {
		this.title = title;
	}
	
	public String getTitlePlural() {
		return titlePlural;
	}
	
	public void setTitlePlural(String titlePlural) {
		this.titlePlural = titlePlural;
	}
	
	public String getAddCommand() {
		return addCommand;
	}
	
	public void setAddCommand(String addCommand) {
		this.addCommand = addCommand;
	}
	
	public String getAddAnotherCommand() {
		return addAnotherCommand;
	}
	
	public void setAddAnotherCommand(String addAnotherCommand) {
		this.addAnotherCommand = addAnotherCommand;
	}

	@Override
	public int hashCode() {
		return dataCollectorId.hashCode();
	}
	
	@Override
	public boolean equals(Object other) {
		return other instanceof RMDataCollectorInfo && dataCollectorId.equals(((RMDataCollectorInfo)other).getDataCollectorId());
	}

	@Override
	public String toString() {
		return "RMDataCollectorInfo [dataCollectorId = " + dataCollectorId + ", baseUrl = " + baseUrl + ", title = " + title + "]";
	}
	
}
