/****************************************************************
 Licensed Materials - Property of IBM and/or HCL 
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/

package com.hcl.test.rm.model;

import java.util.LinkedHashMap;
import java.util.Map;

import io.swagger.annotations.ApiModelProperty;

public class RMObservationSet {

	/**
	 * The id of the owner RMSourceInfo
	 */
	@ApiModelProperty(required = true, notes = "The id of the source this observation set is related to")
	private String sourceId;
	
	@ApiModelProperty(required = true, notes = "The timestamp of the measure in milliseconds since Unix Epoch; the reference clock is the one of the host running the Service")
	private long timestamp;
	
	@ApiModelProperty(required = true,
					  dataType = "Map",
					  notes = "a map whose keys are ObservableData ids and values are Double or String for the actual value or the error message respectively")
	private Map<String, Object> datas = new LinkedHashMap<>();
	
	void setSourceId(String sourceId) {
		this.sourceId = sourceId;
	}
	
	public String getSourceId() {
		return sourceId;
	}
	
	public void setTimestamp(long timestamp) {
		this.timestamp = timestamp;
	}
	
	public long getTimestamp() {
		return timestamp;
	}
	
	void addData(String id, double value) {
		datas.put(id, value);
	}
	
	void addMessage(String id, String message) {
		datas.put(id, message);
	}
	
	public Map<String, Object> getDatas() {
		return datas;
	}
}
