/****************************************************************
 Licensed Materials - Property of IBM and/or HCL
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jquery", "LayoutParticipant", "Nav_template"], function (require, exports, $, LayoutParticipant_1, Nav_template_1) {
    "use strict";
    exports.__esModule = true;
    var AgentsLayout = /** @class */ (function (_super) {
        __extends(AgentsLayout, _super);
        function AgentsLayout() {
            return _super.call(this, 'agents', [], ['AGENT_ADDED', 'AGENT_REMOVED']) || this;
        }
        AgentsLayout.prototype.refresh = function () {
            var _this = this;
            $.ajax({
                url: this.url,
                dataType: 'json',
                headers: {
                    'Cache-Control': 'max-age=0'
                },
                success: function (agents) {
                    _this.display(agents);
                },
                error: function (xhr, textStatus, errorThrown) {
                    $('[data-rm-role="menu-agents"]').trigger('server-error', [xhr, textStatus, errorThrown]);
                }
            });
        };
        AgentsLayout.prototype.display = function (agents) {
            var data = { agents: agents };
            var okAgents = 0;
            var koAgents = 0;
            for (var _i = 0, agents_1 = agents; _i < agents_1.length; _i++) {
                var agent = agents_1[_i];
                if (agent.connected) {
                    okAgents++;
                }
                else {
                    koAgents++;
                }
            }
            if (okAgents) {
                data.okAgents = okAgents;
            }
            if (koAgents) {
                data.koAgents = koAgents;
            }
            $('[data-rm-role="menu-agents"]').replaceWith(Nav_template_1.agentsMenu(data));
        };
        AgentsLayout.prototype.onServerEvent = function (event) {
            switch (event.operation) {
                case 'AGENT_ADDED':
                case 'AGENT_REMOVED':
                    this.refresh();
                    break;
            }
            return false;
        };
        return AgentsLayout;
    }(LayoutParticipant_1.LayoutParticipant));
    exports.AgentsLayout = AgentsLayout;
});
