/****************************************************************
 Licensed Materials - Property of IBM and/or HCL
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "LayoutParticipant"], function (require, exports, LayoutParticipant_1) {
    "use strict";
    exports.__esModule = true;
    var CascadableLayoutManager = /** @class */ (function (_super) {
        __extends(CascadableLayoutManager, _super);
        function CascadableLayoutManager() {
            var _this = _super.call(this, null, []) || this;
            _this.layoutParticipants = [];
            return _this;
        }
        CascadableLayoutManager.prototype.addLayoutParticipant = function (participant) {
            this.layoutParticipants.push(participant);
        };
        CascadableLayoutManager.prototype.removeLayoutParticipant = function (participant) {
            var index = this.layoutParticipants.indexOf(participant);
            if (index >= 0) {
                this.layoutParticipants.splice(index, 1);
            }
        };
        CascadableLayoutManager.prototype.refresh = function () {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                participant.refresh();
            }
        };
        CascadableLayoutManager.prototype.withUrl = function (url) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                if (participant.withUrl(url)) {
                    return true;
                }
            }
            return false;
        };
        CascadableLayoutManager.prototype.withRole = function (role) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                if (participant.withRole(role)) {
                    return true;
                }
            }
            return false;
        };
        CascadableLayoutManager.prototype.withServerEvent = function (serverEvent) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                if (participant.withServerEvent(serverEvent)) {
                    return true;
                }
            }
            return false;
        };
        CascadableLayoutManager.prototype.decorateEventData = function (event) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                participant.decorateEventData(event);
            }
        };
        CascadableLayoutManager.prototype.onEvent = function (event) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                if (event.data && participant.withRole(event.data.role) &&
                    !participant.onEvent(event)) {
                    break;
                }
            }
            if (event.returnValue) {
                return true;
            }
        };
        CascadableLayoutManager.prototype.onServerEvent = function (event) {
            for (var _i = 0, _a = this.layoutParticipants; _i < _a.length; _i++) {
                var participant = _a[_i];
                if (participant.withServerEvent(event.operation) &&
                    !participant.onServerEvent(event)) {
                    return false;
                }
            }
            return true;
        };
        return CascadableLayoutManager;
    }(LayoutParticipant_1.LayoutParticipant));
    exports.CascadableLayoutManager = CascadableLayoutManager;
});
