/****************************************************************
 Licensed Materials - Property of IBM and/or HCL
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/
define(["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    /*
     * this object is constructed by Main.ts
    */
    var Constants = /** @class */ (function () {
        function Constants() {
            Constants.instance = this;
            this.isIBMBuild = this.detectBuild();
        }
        /** to detect IBM vs HCL build, get one of token with plugin name
          * then checl if its com.hcl....
          */
        Constants.prototype.detectBuild = function () {
            var offering = "com.ibm.rational.performance.tester"; //offering id, see com.hcl.wash.releng
            if (offering.lastIndexOf("com.ibm.", 0) === 0) {
                return true; //IBM build 
            }
            else {
                return false; //HCL build, or dev (no token replacement)
            }
        };
        Constants.getHelpUrl = function () {
            if (this.instance.isIBMBuild) {
                return "https://www.ibm.com/support/knowledgecenter/SSMMM5_9.5.0/com.ibm.rational.test.lt.common.doc/topics/c_rm_service.html";
            }
            else {
                return "https://hclonetestperformance.hcldoc.com/help/topic/com.ibm.rational.test.lt.common.doc/topics/c_rm_service.html";
            }
        };
        Constants.instance = null;
        return Constants;
    }());
    exports.Constants = Constants;
});
