import "jquery.form";
import "jquery.serializejson";
import "jquery.validate";
import { FormHallManager, FormHallManagerHandlers } from "FormHallManager";
export interface FormHallBuilderOptions {
    baseUrl: string;
    formRelUrl: string;
    uniqueId: string;
    handlers?: FormHallManagerHandlers;
}
export declare class FormHallBuilder {
    options: FormHallBuilderOptions;
    formModel: any;
    manager: FormHallManager;
    constructor(options: FormHallBuilderOptions, then: (mapper: FormHallBuilder) => void);
    setHandlers(handlers: FormHallManagerHandlers): void;
    private setupModalListeners(modalSelector);
    private getId(forEdit, withModal);
    private createManager(formId, modalId?);
    private prepareModal(forEdit);
    /** Returns the id attribute of the bootstrap modal that can then be shown with $('#' + id).modal('show'); */
    prepareModalCreate(): string;
    /** Returns the id attribute of the bootstrap modal that can then be shown with $('#' + id).modal('show'); */
    prepareModalEdit(): string;
    showForm(placeholderSel: string, forEdit: boolean): string;
    /** Returns the id attribute of the form element that is appended into the placeholder element */
    showFormCreate(placeholderSel: string): string;
    /** Returns the id attribute of the form element that is appended into the placeholder element */
    showFormEdit(placeholderSel: string): string;
    /** To be called after prepareModal...() or showForm...() */
    withData(data: any): void;
}
