/// <reference types="jquery.validation" />
/// <reference types="jquery" />
import "jquery.form";
import "jquery.serializejson";
import "jquery.validate";
import "bootstrap";
export interface FormHallManagerHandlers {
    whenSuccess?: (request?: any) => void;
    whenError?: () => void;
    customSubmit?: (manager: FormHallManager, data: any) => void;
}
export declare class FormHallManager {
    formSelector: string;
    handlers: FormHallManagerHandlers;
    $form: JQuery<HTMLElement>;
    validator: JQueryValidation.Validator;
    onShowListeners: {
        (): void;
    }[];
    updateDataListeners: {
        (): void;
    }[];
    dirty: boolean;
    keepMessages: boolean;
    constructor(formSelector: string, handlers: FormHallManagerHandlers);
    setHandlers(handlers: FormHallManagerHandlers): void;
    installDefaultValues(): void;
    adaptConstraints(): void;
    adaptInputConstraints($input: JQuery<HTMLElement>, constraints: any): void;
    adaptInputRanges(): void;
    setupChoiceItemsUrls(): void;
    populateChoiceItemsFrom($element: JQuery<HTMLElement>, url: string, keepFirst: boolean): void;
    installDepends(): void;
    installValidate(): void;
    onShow(): void;
    onShown(): void;
    onHide(): void;
    onHidden(): void;
    isCreateForm(): boolean;
    onSubmitStart(): void;
    onSubmitComplete(): void;
    submitHandler(form: HTMLFormElement): void;
    defaultSubmit(data: any): void;
    hideMessageAreas(): void;
    onSuccess(message: string, request?: any): void;
    onError(message: string): void;
    addUpdateDataListener(handler: () => void): void;
    onUpdateData(): void;
    updateFrom(location: string, onSuccess?: (data: any) => void, onError?: (request: JQuery.jqXHR, textStatus: JQuery.Ajax.ErrorTextStatus, errorThrown: string) => void): void;
    getValueForName(name: string, data: any): string;
    populateWith(data: any): void;
    toggleDependency(dependsSel: string, $container: JQuery<HTMLElement>, depends: any): void;
    interpretSelector(dependsSel: string, selector: string): boolean;
    interpretFunctionalSelector($property: any, selector: any, lparIndex: any): boolean;
    disableSubmitReset(disabled: boolean): void;
    setDirty(dirty: boolean): void;
}
