/****************************************************************
 Licensed Materials - Property of IBM and/or HCL
(c) Copyright HCL Technologies Ltd. 2018.  All Rights Reserved.

 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule:
 Contract with IBM Corp.
*****************************************************************/
define(["require", "exports"], function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var LayoutParticipant = /** @class */ (function () {
        function LayoutParticipant(url, roles, serverEvents) {
            if (serverEvents === void 0) { serverEvents = []; }
            this.url = url;
            this.roles = roles;
            this.serverEvents = serverEvents;
        }
        LayoutParticipant.prototype.withUrl = function (url) {
            // Default with url given during construction, override for another behavior
            return this.url === url;
        };
        LayoutParticipant.prototype.withRole = function (role) {
            // Default with roles given during construction, override for another behavior
            return this.roles.indexOf(role) >= 0;
        };
        LayoutParticipant.prototype.withServerEvent = function (serverEvent) {
            // Default with roles given during construction, override for another behavior
            return this.serverEvents.indexOf(serverEvent) >= 0;
        };
        LayoutParticipant.prototype.decorateEventData = function (event) {
            // Default implementation does nothing and let the event bubble, override for another behavior
        };
        /**
         * Returns true to allow remaining participants to get called, false otherwise
         */
        LayoutParticipant.prototype.onEvent = function (event) {
            // Default implementation does nothing and let the event bubble, override for another behavior
            return true;
        };
        /**
         * Returns true to allow remaining participants to get called, false otherwise
         */
        LayoutParticipant.prototype.onServerEvent = function (event) {
            // Default implementation does nothing and let the event reach others, override for another behavior
            return true;
        };
        return LayoutParticipant;
    }());
    exports.LayoutParticipant = LayoutParticipant;
});
